%{
#include "ael.tab.h"
static int parencount = 0;
static int commaout = 0;
int my_lineno = 1;
%}

%x paren semic argg
%option bison-bridge
%option bison-locations
%option yylineno
%option noyywrap

%%
\{	{yylloc->first_line = yylloc->last_line = my_lineno; return LC;}
\}	{yylloc->first_line = yylloc->last_line = my_lineno; return RC;}
\(	{yylloc->first_line = yylloc->last_line = my_lineno; return LP;}
\)	{yylloc->first_line = yylloc->last_line = my_lineno; return RP;}
\;	{yylloc->first_line = yylloc->last_line = my_lineno; return SEMI;}
\=	{yylloc->first_line = yylloc->last_line = my_lineno; return EQ;}
\,	{yylloc->first_line = yylloc->last_line = my_lineno; return COMMA;}
\:	{yylloc->first_line = yylloc->last_line = my_lineno; return COLON;}
\&	{yylloc->first_line = yylloc->last_line = my_lineno; return AMPER;}
\|	{yylloc->first_line = yylloc->last_line = my_lineno; return BAR;}
\=\>	{yylloc->first_line = yylloc->last_line = my_lineno; return EXTENMARK;}
context	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_CONTEXT;}
macro	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_MACRO;};
globals	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_GLOBALS;}
ignorepat	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_IGNOREPAT;}
switch	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_SWITCH;}
if	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_IF;}
else	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_ELSE;}
goto	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_GOTO;}
return	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_RETURN;}
break	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_BREAK;}
continue	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_CONTINUE;}
for	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_FOR;}
while	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_WHILE;}
case	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_CASE;}
default	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_DEFAULT;}
catch	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_CATCH;}
switches	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_SWITCHES;}
eswitches	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_ESWITCHES;}
includes	{yylloc->first_line = yylloc->last_line = my_lineno; return KW_INCLUDES;}

"//".*$		{/* throw away printf("Skipping COMMENT %s\n\n",yytext); */ }
\n		{my_lineno++;}
[ 	]+	{/* nothing */ }

[-a-zA-Z0-9_/.$][-a-zA-Z0-9_/.\{\}$]*	{yylloc->first_line = yylloc->last_line = my_lineno; /* set up the ptr */yylval->str = strdup(yytext);  /* printf("Got WORD %s\n", yylval->str);*/ return word;}



<paren>[^()]*\)	{yylloc->first_line = yylloc->last_line = my_lineno; parencount--;if( parencount >= 0){yymore();} else { yylval->str = strdup(yytext); /* printf("Got paren word %s\n", yylval->str); */ unput(')'); BEGIN(0); return word;} }
<paren>[^()]*\(	{yylloc->first_line = yylloc->last_line = my_lineno; parencount++; yymore();};



<argg>[^(),]*\)	{yylloc->first_line = yylloc->last_line = my_lineno; parencount--;if( parencount >= 0)
                                   { yymore(); }
                              else { yylval->str = strdup(yytext); 
                                     /* printf("Got argg word '%s'\n", yylval->str);  */
                                     BEGIN(0); 
                                     if( !strcmp(yylval->str,")") ) 
                                         { return RP;  }
                                     else 
                                         {unput(')'); return word;}
                                    } 
                }
<argg>[^(),]*\(	{/* printf("GOT AN LP!!!\n"); */yylloc->first_line = yylloc->last_line = my_lineno; parencount++; yymore();};
<argg>[^(),]*\,	{yylloc->first_line = yylloc->last_line = my_lineno;  
                  if( parencount != 0)
                  { /* printf("Folding in a comma!\n"); */ yymore();} 
                  else 
                  { /* printf("got a comma!\n\n");  */
                     if( !commaout )
                     { yylval->str = strdup(yytext); /* printf("Got argg2 word %s\n", yylval->str); */ unput(','); commaout = 1; return word;}
                     else
                     { commaout = 0; return COMMA; }
                   }; }


<semic>[^;]*;	{yylloc->first_line = yylloc->last_line = my_lineno;  yylval->str = strdup(yytext); /* printf("Got semic word %s\n", yylval->str); */ unput(';'); BEGIN(0); return word; }

%%

void reset_parencount(void)
{
	parencount = 0;
	BEGIN(paren);
}

void reset_semicount(void)
{
	BEGIN(semic);
}

void reset_argcount(void)
{
	parencount = 0;
	commaout = 0;
	BEGIN(argg);
}

void parse_extensions(void)
{
	yyin = fopen("/etc/asterisk/extensions.ael","r");
	yyparse();
}

int main(int argc, char **argv)
{
	//extern int yydebug;
	// yydebug =1;
	parse_extensions();
}

